﻿/**
 * Copyright 2008 - TMTDigital LLC
 *
 * Author:   Travis Tidwell (www.travistidwell.com)
 * Version:  1.0
 * Date:     June 9th, 2008
 *
 * Description:  The main node that is being shown in the Dash Player.
 *
 **/

package com.tmtdigital.dash.display.node
{
   import com.tmtdigital.dash.display.node.NodeBase;
   import com.tmtdigital.dash.display.Spinner;
   import com.tmtdigital.dash.config.Params;

   import flash.display.*;
   import flash.events.*;
   import flash.net.*;
   import flash.geom.*;

   public class Node extends NodeBase
   {
      public function Node( _skin:MovieClip )
      {
         super( _skin );
      }

      public override function setSkin( _skin:MovieClip )
      {
         super.setSkin( _skin );
         
         // Set the node control bar.
         if( fields && fields.media ) {
            fields.media.setControlBar( "node" );
         }			
         
			spinner = new Spinner( skin.loader, "node" );
      }

      /**
       * Loads any given node.
       *
       * @param - The node ID or the node object of the node to load.
       * @param - Boolean to indicate if you would like to increment the node counter or not.
       */
      public override function loadNode( nodeId:* = null ):Boolean
      {
         var service:Boolean = super.loadNode(nodeId);
         if ( service && spinner ) {
            spinner.visible = true;
         }
         return service;
      }

      public function refresh()
      {
         if (node) {
            super.onNodeLoad( node );
         }
      }

      /**
       *  Called when the service call returns with the actual node object.
       *
       *  @param - The node object of this given node.
       */
      public override function onNodeLoad( _node:Object )
      {
			//spinner.visible = false;
         super.onNodeLoad( _node );

         if (rootSkin.onNodeLoad is Function) {
            rootSkin.onNodeLoad( _node );
         }
      }

      /**
       *  Called after a resize process has finished.  Here we just want to make sure that
       *  our loader movie clip is centered on this node.
       */
      public override function postResize()
      {
         super.postResize();
			
			if( spinner && fields && fields.media && fields.media.mediaRegion ) {
				spinner.postResize( fields.media.mediaRegion.width, fields.media.mediaRegion.height );
			}
      }

      public var spinner:Spinner;
   }
}